<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!-- This collection of hypertext pages is Copyright 1995, 1996 by Steve Summit. -->
<!-- This material may be freely redistributed and used -->
<!-- but may not be republished or sold without permission. -->
<html>
<head>
<link rev="owner" href="mailto:scs@eskimo.com">
<link rev="made" href="mailto:scs@eskimo.com">
<title>5.2 Function Prototypes</title>
<link href="sx5a.html" rev=precedes>
<link href="sx5c.html" rel=precedes>
<link href="sx5.html" rev=subdocument>
</head>
<body>
<H2>5.2 Function Prototypes</H2>

<p>In modern C programming,
it is considered good practice to use prototype declarations
for all functions that you call.
As we mentioned, these prototypes help to ensure that the 
compiler can generate correct code for calling the functions,
as well as allowing the compiler to catch certain mistakes you 
might make.
</p><p>Strictly speaking, however, prototypes are optional.
If you call a function for which the compiler has not seen a 
prototype,
the compiler will do the best it can,
assuming that you're calling the function correctly.
</p><p>If prototypes are a good idea,
and if we're going to get in the habit of writing
function prototype declarations for
functions we call that we've written (such as <TT>multbytwo</TT>),
what happens for library functions such as <TT>printf</TT>?
Where are their prototypes?
The answer is in that boilerplate line
<pre>
	#include &lt;stdio.h&gt;
</pre>
we've been including at the top of all of our programs.
<TT>stdio.h</TT> is conceptually a file full of
external declarations and other information
pertaining to the ``Standard I/O''
library functions, including <TT>printf</TT>.
The <TT>#include</TT> directive
(which we'll meet formally in a later chapter)
arranges that all of the declarations within <TT>stdio.h</TT>
are considered

by the compiler,
rather as if we'd typed them all in ourselves.
Somewhere within these declarations
is an external function prototype declaration for <TT>printf</TT>,
which satisfies the rule that there should be a prototype
for each function we call.
(For other standard library functions we call,
there will be other ``header files'' to include.)
Finally, one more thing about external function prototype declarations.
We've said that the distinction between external declarations and
defining instances of normal variables
hinges on the presence or absence of the keyword <TT>extern</TT>.
The situation is a little bit different for functions.
The ``defining instance'' of a function is the function,
including its body (that is, the brace-enclosed list of
declarations and statements implementing the function).
An external declaration of a function, even without the keyword
<TT>extern</TT>, looks nothing like a function declaration.
Therefore, the keyword <TT>extern</TT> is optional in
function prototype declarations.
If you wish,
you can write
<pre>
	int multbytwo(int);
</pre>
and this is just as good an external function prototype
declaration as
<pre>
	extern int multbytwo(int);
</pre>
(In the first form,
without the <TT>extern</TT>,
as soon as the compiler sees the semicolon, it knows it's not
going to see a function body, so the declaration can't be a definition.)
You may want to stay in the habit of using <TT>extern</TT>
in all external declarations, including function declarations,
since ``<TT>extern</TT> = external declaration''
is an easier rule to remember.
</p><hr>
<p>
Read sequentially:
<a href="sx5a.html" rev=precedes>prev</a>
<a href="sx5c.html" rel=precedes>next</a>
<a href="sx5.html" rev=subdocument>up</a>
<a href="top.html">top</a>
</p>
<p>
This page by <a href="http://www.eskimo.com/~scs/">Steve Summit</a>
// <a href="copyright.html">Copyright</a> 1995, 1996
// <a href="mailto:scs@eskimo.com">mail feedback</a>
</p>
</body>
</html>
